// Solutions to the Advent Of Code 2024.
// Copyright (C) 2024-2025  Stefan Müller
//
// This program is free software: you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation, either version 3 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// this program.  If not, see <http://www.gnu.org/licenses/>.

#pragma once

#include <cstdint>

class MullData
{
public:
    MullData();
    bool getIsEnabled() const;
    void setIsEnabled(const bool value);
    int getFactor(const int index) const;
    void setFactor(const int index, const int value);
    void updateResult();
    int64_t getResultPart1() const;
    int64_t getResultPart2() const;
private:
    bool isEnabled_;
    int factor1_;
    int factor2_;
    int64_t part1_;
    int64_t part2_;
};
