// Solutions to the Advent Of Code 2024.
// Copyright (C) 2024  Stefan Müller
//
// This program is free software: you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation, either version 3 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// this program.  If not, see <http://www.gnu.org/licenses/>.

#pragma once

#include <aoc/extra/MullCharState.hpp>
#include <aoc/extra/MullDoOpenState.hpp>
#include <aoc/extra/MullEntryState.hpp>
#include <aoc/extra/MullFactorState.hpp>
#include <aoc/extra/MullToggleCloseState.hpp>

class MullStates
{
public:
    MullStates(MullData& data);
    MullEntryState entryState;
    MullCharState uState{ 'u' };
    MullCharState lState{ 'l' };
    MullCharState mulOpenState{ '(' };
    MullFactorState factor1State{ ',', 1 };
    MullFactorState factor2State{ ')', 2 };
    MullCharState oState{ 'o' };
    MullDoOpenState doOpenState;
    MullToggleCloseState doCloseState{ true };
    MullCharState apostropheState{ '\'' };
    MullCharState tState{ 't' };
    MullCharState dontOpenState{ '(' };
    MullToggleCloseState dontCloseState{ false };
};
