// Solutions to the Advent Of Code 2024.
// Copyright (C) 2024  Stefan Müller
//
// This program is free software: you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation, either version 3 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// this program.  If not, see <http://www.gnu.org/licenses/>.

#include <aoc/extra/MullToggleCloseState.hpp>

MullToggleCloseState::MullToggleCloseState(const bool isEnabler)
    : isEnabler_{ isEnabler }, successState_{}
{
}

void MullToggleCloseState::next(StringStateMachine* stateMachine)
{
    if (stateMachine->getCurrent() == ')')
    {
        data_->setIsEnabled(isEnabler_);
    }
    stateMachine->setState(*successState_);
}

void MullToggleCloseState::setTransitions(StringState& successState)
{
    successState_ = &successState;
}
